<?php
/*****************************
Разработчик: Валерий Корецкий
Сайт: http://valerykoretsky.com/
Продукт: Таймер/Счетчик обратного отсчета
Дата выпуска: 22.07.2014
Статус: Free
*****************************/
	
	/* Отключеняем вывод ошибок */
	error_reporting(0);

	/* Подключаем необходимые файлы */
	require_once 'timer/tools/iddb.class.php'; // Класс для работы с IDDB (текстовая база данных в одно поле)
	require_once 'timer/tools/timer.class.php'; // Класс для работы самого таймера
	require_once 'timer/tools/config.php'; // Файл конфигураций

	/* Создаем экземпляры классов */	
	$iddb = new IDDB;
	$timer = new TIMER($config);	

	/* Получаем значение таймера (в секундах) */
	$timer_value = $timer->getTime();
		
	/* Делаем проверку на отображение разных страниц */
	if($config['page_html']==1) {
		if($timer_value>0) { // проверяем активный ли таймер или время уже истекло
			if($config['page_on']=='') { die('Ошибка! Не задана страница с активным таймером!'); } // обработка ошибок
			$file = $config['page_on'];
		} else {
			if($config['page_off']=='') { die('Ошибка! Не задана страница с выключенным таймером!'); }
			$file = $config['page_off'];
		}
		if(eregi('.php$',$file) && !eregi('http:$',$file)) { // прореяем находится ли файл на текущем сервере и имеет ли расширение *.php
			// если файл на нашем сервере, используем буффер вывода для исполнения его кода
			ob_start(); // включаем буффер вывода
			require_once $file; // подключаем текущий файл
			$file = ob_get_contents(); // записываем результат выполенения
			ob_end_clean(); // очищаем буффер
		} else {
			// если файл на другом сервере, получаем его содержание
			$file = @file_get_contents($file);
		}
		echo $file; // выводим результат
		die(); // прерываем выполнение скрипта
	}
	
	/* Делаем проверку на включенный редирект при неактивном таймере */
	if($config['redirect_end']==1 && $timer_value<1) {
		if($config['redirect_url']=='') { die('Ошибка! Не указана ссылка для перенаправления!'); }
		header('Location: '.$config['redirect_url']); // делаем редирект на указанную страницу
		die(); // прерываем выполнение скрипта
	}
	
	/* Выводим стандартный код таймера */
	echo '<iframe id="timer_iframe" src="timer/iframe_timer.php" frameborder="0" style="width:100%;"></iframe>';
?>

